; FILE: PA0WSO.asm
; Simple callgever controller for 16F84


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


        list  P=16F84,C=132,R=DEC   ; Start de assembler  

        #include p16f84.inc           ; Register Definities van de processor

;
; HS oscillator (4 MHz Xtal)	XT
; Watchdog timer disabled	WDT
; Power-up timer enabled	PWRTE
; Code protection off		CP

      __config _XT_OSC & _PWRTE_ON & _WDT_OFF & _CP_OFF ;  config instelling


; For code at 10 WPM, each unit is 120 milliseconds long.
; This is 90 cycles of a 750 Hz tone.;
      
 
; our variables
cblock	h'0c'	
	speed
	cnt	
	cyc 	
	units      
	tmp     
endc

       org   0x000		; The main line code starts here

 
; First we do all required initialization

       
Start

; Set port A as output
        bsf   	STATUS,RP0 	;Bank 1
	movlw	0
        movwf   TRISA		;Port A outputs
	movlw	h'7f'
        movwf   TRISB		;Port B 0-6 inputs, 7 output
; Enable port B pullups
;       bsf     OPTION_REG,NOT_RBPU	;Pull-up resistor port B active

; Switch back to bank 0
        bcf     STATUS,RP0	;Bank 0
        bcf     PORTA,2		;set testbit laag 
	bsf     PORTB,7		;set RB7 high		
;------------------------------------------------------------
; Delay units * 60 cycles of 750 Hz tone
	movlw	70		;load morse speed
	movwf   speed
;---------------------------------------------------------------
; Ready for main loop
Top
	bsf     PORTB,7		;set RB7 high
	btfss	PORTB,0		;SW1 low?
	call	CQ
	btfss	PORTB,1		;SW2 low?
	call	K
	btfss	PORTB,2		;SW3 low?
	call	TOON
	bcf     PORTA,1		;set RA1 low
	goto	Top

TOON	movlw   008		;wait 1 seconds (8x120msec)
	movwf   units
	call    dlunit

	bcf     PORTB,7		;key the transmitter

TOON1	movlw	1
	movwf	units
	call	tnunit		;one 750 Hz cycl.

	bcf     PORTB,7		;key the transmitter

	btfss	PORTB,2		;SW3 low?
	goto	TOON1

        bsf     PORTB,7		;unkey the transmitter   
	return

;Routine for sending roger beep (K)

K	btfsc	PORTB,1		;SW1 low?
	return
	call	test		;Roger beep on
	btfsc	PORTB,4		;PTT2 high?
	goto	K

PTTl	btfsc	PORTB,1		;SW1 low?
	return
	btfss	PORTB,4		;PTT2 low?
	goto	PTTl

	bcf     PORTB,7		;key the transmitter

	movlw   004		;wait .5 seconds (4x120msec)
	movwf   units
	call    dlunit

	call	SentK

	bsf     PORTB,7		;unkey the transmitter   
	
	return

;Routine for sending CQ CQ

CQ	bcf     PORTB,7		;key the transmitter

        movlw   008		;wait 1 seconds (8x120msec)
	movwf   units
	call    dlunit

	call    SentCQ		;send CQ

        movlw   008		;wait 1 seconds (8x120msec)
	movwf   units
	call    dlunit

	btfss	PORTB,0		;PTT high?
	goto	CQ

	call	SentK
  
	movlw   024		;wait 3 seconds (24x120msec)
	movwf   units
	call    dlunit

	bsf     PORTB,7 	;unkey the transmitter 
	return
;---------------------------------------------------------------;
;               ID message                                      ;
;               PA0WSO QTH Vollenhove JO22XQ                    ;
;---------------------------------------------------------------;
SentCQ
	call	_c
        call    _q
        call    pause
	call	_c
        call    _q
        call    pause
	call	_c
        call    _q
        call    pause
	call	_d
        call    _e
        call    pause
	call	_p
        call    _a
        call    _0
        call    _w
        call    _s
        call    _o
        call	pause
	call	_p
        call    _a
        call    _0
        call    _w
        call    _s
        call    _o
        call	pause
        call    pause
        call    _q
        call    _t
        call    _h
        call	pause
        call    _v
        call    _o     
        call    _l
        call    _l     
        call    _e
        call    _n     
        call    _h
        call    _o     
        call    _v
        call    _e
        call	pause     
        call    _j     
        call    _o     
        call    _2     
        call    _2     
        call    _q     
        call    _x     
        return
;-------------------------------------------------------------
;            Send rogger beep
;--------------------------------------------------------------
SentK	call    _k
	return

; Send a dot
di	movlw   1
        movwf   units
        call    tnunit	;dot-tone
        movlw   1
        movwf   units
        call    dlunit	;gap
        return

;Send a dash
dah	movlw   3	
        movwf   units	
        call    tnunit	;dash-tone
        movlw   1
        movwf   units
        call    dlunit	;gap
        return

;Finish a space
spatie  movlw   2
        movwf   units
        call    dlunit	;space
        return

;Finish a pause
pause	movlw   6
        movwf   units
        call    dlunit	;pause
        return

;---------------------------------------------------------------;
; De MORSEcode cijfers en letters
;---------------------------------------------------------------;

_p      call    di
        goto    _g
_9      call    dah
        call    dah
_g      call    dah
        goto    _n
_c      call    dah
        goto    _r
_f      call    di
_r      call    di
_n      call    dah
        goto    _e
_l      call    di
        goto    _d
_8      call    dah
_z      call    dah
_d      call    dah
        goto    _i
_7      call    dah
_b      call    dah
        goto    _s
_6      call    dah
        goto    _h
_5      call    di
_h      call    di
_s      call    di
_i      call    di
_e      call    di
        goto    spatie

_q      call    dah
_k      call    dah
        goto    _a
_x      call    dah
        goto    _u
_4      call    di
_v      call    di
_u      call    di
_a      call    di
        goto    _t
_y      call    dah
        goto    _w
_3      call    di
        call    di
_w      call    di
        goto    _m
_2      call    di
_j      call    di
        goto    _o
_1      call    di
        goto    0o
_0      call    dah
_0o     call    dah
_o      call    dah
_m      call    dah
_t      call    dah
        goto    spatie

; Delay units * 60 cycles of 750 Hz tone
dlunit  movf	speed,0
        movwf   cyc
dlhi    nop
        bcf     PORTA,0		;set tone bit low
        call    haf		;wait a bit

        nop			;waste 8 cycles for symmetry
        movlw   2
        movwf   tmp
dlmid   decfsz  tmp,1
        goto    dlmid

        bcf     PORTA,0		;set tone bit low
        call    haf		;wait a bit

        decfsz  cyc,1		;one less cycle to send
        goto    dlpad		;do another cycle

        decfsz  units,1		;Another unit done
        goto    dlunit
        return

dlpad   nop			;4 cycles for padding
        nop
        goto    dlhi


; Send units * 60 cycles of 750 Hz tone
tnunit  movf	speed,0
        movwf   cyc
tnhi    nop
        bsf     PORTA,0		;set tone bit high
        bsf     PORTA,1		;Monitor led
        call    haf		;wait a bit

        nop			;waste 8 cycles for symmetry
        movlw   2
        movwf   tmp
tnmid   decfsz  tmp,1
        goto    tnmid

        bcf     PORTA,0		;set tone bit low
        bcf     PORTA,1		;Monitor led
        call    haf		;wait a bit

        decfsz  cyc,1		;one less cycle to send
        goto    tnpad		;do another cycle

        decfsz  units,1		;Another unit done
        goto    tnunit
        return

tnpad   nop			;4 cycles for padding
        nop
        goto    tnhi



; delay for half a cycle of 750 Hz

; A 750 HZ tone is 1.333333 milliseconds
; in duration.  This means each half cycle
; of the tone is 666.6666 microseconds.
; Since I'm using a 4.0 MHz Xtal, this
; is 666 CPU cycles per tone half cycle.

; Since the routine that calls this to generate
; the tone takes 11 CPU cycles per Tone half
; cycle, we need to burn up 666 CPU cycles
; in this routine.

; This routine takes 13 + ((K -1) * 4) cycles
; where K is the argument for the movlw
; instruction.

haf
        nop
        nop
        nop
        movlw   163	;tone 750 Hz
        movwf   cnt
luphaf
        nop
        decfsz  cnt,1
        goto    luphaf
        goto    lupxt
lupxt   nop
        return
	
test	bsf     PORTA,2		;set testbit hoog

	movlw   008		;wait 1 seconds (8x120msec)
	movwf   units
	call    dlunit

	bcf     PORTA,2		;set testbit laag

	movlw   008		;wait 1 seconds (8x120msec)
	movwf   units
	call    dlunit
	bsf     PORTA,2		;set testbit hoog

	movlw   008		;wait 1 seconds (8x120msec)
	movwf   units
	call    dlunit

	bcf     PORTA,2		;set testbit laag

	return

	end


	


